/* radare - Copyright 2011-2019 pancake<nopcode.org> */
/* $OpenBSD: magic.c,v 1.8 2009/10/27 23:59:37 deraadt Exp $ */

#include <r_userconf.h>
#include <r_magic.h>

R_LIB_VERSION (r_magic);

#ifdef _MSC_VER
# include <io.h>
# include <sys\stat.h>
# define S_ISREG(m) (((m) & S_IFMT) == S_IFREG)
# define S_ISDIR(m) (((m) & S_IFMT) == S_IFDIR)
# define S_IFIFO (-1)
# define S_ISFIFO(m) (((m) & S_IFIFO) == S_IFIFO)
# define MAXPATHLEN 255
#endif


// we keep this code just to make debian happy, but we should use
// our own magic implementation for consistency reasons
#include <magic.h>
#undef R_API
#define R_API

R_API RMagic* r_magic_new(int flags) {
	return magic_open (flags);
}
R_API void r_magic_free(RMagic* m) {
	if (m) {
		magic_close (m);
	}
}
R_API const char *r_magic_file(RMagic* m, const char *f) { return magic_file(m, f); }
R_API const char *r_magic_descriptor(RMagic* m, int fd) { return magic_descriptor(m, fd); }
R_API const char *r_magic_buffer(RMagic* m, const void *b, size_t s) { return magic_buffer(m, b, s); }
R_API const char *r_magic_error(RMagic* m) { return magic_error(m); }
R_API void r_magic_setflags(RMagic* m, int f) { magic_setflags(m, f); }
R_API bool r_magic_load(RMagic* m, const char *f) { return magic_load(m, f) != -1; }
R_API bool r_magic_compile(RMagic* m, const char *x) { return magic_compile(m, x) != -1; }
R_API bool r_magic_check(RMagic* m, const char *x) { return magic_check(m, x) != -1; }
R_API int r_magic_errno(RMagic* m) { return magic_errno(m); }

